% Script for creating feasible routes printing them as input for use in XPRESS IVE
clc
clear all
 tic 
% 
%Reads for small service vessels
TimeWindowsmallservice = xlsread('Inputloopgeneration.xlsx','Smallservice','F4:F288'); %Read in latest start of task
JobDurationsmallservice = xlsread('Inputloopgeneration.xlsx','Smallservice','G4:G288'); %Read in duration of each job
TravelDistancesmallservice = xlsread('Inputloopgeneration.xlsx','Smallservice','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotsmallservice = xlsread('Inputloopgeneration.xlsx','Smallservice','I4:I288'); %Read in the distance from the depot to each job
Costtimesmallservice=xlsread('Inputloopgeneration.xlsx','Smallservice','A4');%Read the cost/hour of operations for the vessel

%Reads for Medium service vessel 
TimeWindowMediumservice = xlsread('Inputloopgeneration.xlsx','Mediumservice','F4:F288'); %Read in latest start of task
JobDurationMediumservice = xlsread('Inputloopgeneration.xlsx','Mediumservice','G4:G288'); %Read in duration of each job
TravelDistanceMediumservice = xlsread('Inputloopgeneration.xlsx','Mediumservice','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotMediumservice = xlsread('Inputloopgeneration.xlsx','Mediumservice','I4:I288'); %Read in the distance from the depot to each job
CosttimeMediumservice=xlsread('Inputloopgeneration.xlsx','Mediumservice','A5');%Read the cost/hour of operations for the vessel

%Reads for large service vessels
TimeWindowLargeservice = xlsread('Inputloopgeneration.xlsx','Largeservice','F4:F288'); %Read in latest start of task
JobDurationLargeservice = xlsread('Inputloopgeneration.xlsx','Largeservice','G4:G288'); %Read in duration of each job
TravelDistanceLargeservice = xlsread('Inputloopgeneration.xlsx','Largeservice','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotLargeservice = xlsread('Inputloopgeneration.xlsx','Largeservice','I4:I288'); %Read in the distance from the depot to each job
CosttimeLargeservice=xlsread('Inputloopgeneration.xlsx','Largeservice','A5');%Read the cost/hour of operations for the vessel

%Reads for smallwellboats
TimeWindowsmallwellboats = xlsread('Inputloopgeneration.xlsx','Smallwell','F4:F288'); %Read in latest start of task
JobDurationsmallwellboats= xlsread('Inputloopgeneration.xlsx','Smallwell','G4:G288'); %Read in duration of each job
TravelDistancesmallwellboats = xlsread('Inputloopgeneration.xlsx','Smallwell','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotsmallwellboats = xlsread('Inputloopgeneration.xlsx','Smallwell','I4:I288'); %Read in the distance from the depot to each job
Costtimesmallwellboats=xlsread('Inputloopgeneration.xlsx','Smallwell','A5');%Read the cost/hour of operations for the vessel


%Reads for large wellboats
TimeWindowLargewell = xlsread('Inputloopgeneration.xlsx','Largewell','F4:F288'); %Read in latest start of task
JobDurationLargewell = xlsread('Inputloopgeneration.xlsx','Largewell','G4:G288'); %Read in duration of each job
TravelDistanceLargewell = xlsread('Inputloopgeneration.xlsx','Largewell','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotLargewell = xlsread('Inputloopgeneration.xlsx','Largewell','I4:I288'); %Read in the distance from the depot to each job
CosttimeLargewell=xlsread('Inputloopgeneration.xlsx','Largewell','A5');%Read the cost/hour of operations for the vessel

%Reads for Medium service vessel with lice equipment
TimeWindowMediumservicelice = xlsread('Inputloopgeneration.xlsx','Mediumservicelice','F4:F288'); %Read in latest start of task
JobDurationMediumservicelice = xlsread('Inputloopgeneration.xlsx','Mediumservicelice','G4:G288'); %Read in duration of each job
TravelDistanceMediumservicelice = xlsread('Inputloopgeneration.xlsx','Mediumservicelice','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotMediumservicelice = xlsread('Inputloopgeneration.xlsx','Mediumservicelice','I4:I288'); %Read in the distance from the depot to each job
CosttimeMediumservicelice=xlsread('Inputloopgeneration.xlsx','Mediumservicelice','A5');%Read the cost/hour of operations for the vessel

%Reads for Large service vessel with lice equipment
TimeWindowLargeservicelice = xlsread('Inputloopgeneration.xlsx','Largeservicelice','F4:F288'); %Read in latest start of task
JobDurationLargeservicelice = xlsread('Inputloopgeneration.xlsx','Largeservicelice','G4:G288'); %Read in duration of each job
TravelDistanceLargeservicelice = xlsread('Inputloopgeneration.xlsx','Largeservicelice','N4:KL288'); %Read in travel distances between the different jobs
DistanceFromDepotLargeservicelice = xlsread('Inputloopgeneration.xlsx','Largeservicelice','I4:I288'); %Read in the distance from the depot to each job
CosttimeLargeservicelice=xlsread('Inputloopgeneration.xlsx','Largeservicelice','A5');%Read the cost/hour of operations for the vessel

taskspr=15; %The number of task types included in the task generation
lokas=19; % Number of locations included in the task generation
Vesseltypes=7; % Number of vesseltypes


% This first part generates all loops for the small service vessels. The
% same prosedure will be used to generate loops for all vessel types

Timesmallservice = zeros(taskspr*lokas,400000); %Create a Time matrix with sufficient space

Asmallservice = zeros(taskspr*lokas,400000); %Create binary feasible routes matrix with sufficient space
numRoutessmallservice = 0; %Set initial number of feasible routes


for i = 1:length(DistanceFromDepotsmallservice)
    k = 0;
   
    if DistanceFromDepotsmallservice(i) < TimeWindowsmallservice(i) %Check feasible start jobs. 
        numRoutessmallservice = numRoutessmallservice + 1; %Create a route for each feasible start job.
        Asmallservice(i,numRoutessmallservice) = 1; %Add job to new row
        Timesmallservice(i,numRoutessmallservice) = DistanceFromDepotsmallservice(i) + JobDurationsmallservice(i); %Add new time to new row
        
        n = 1; %Set counter for number of jobs in the route
        
        Store1smallservice = []; %Create store matrix 1 to keep track of jobs already visited
        Store2smallservice = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %This decides how many jobs can be added in one route.
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationsmallservice)
                    if  (Timesmallservice(i,numRoutessmallservice) + TravelDistancesmallservice(i,j)) < TimeWindowsmallservice(j)...
                        && TravelDistancesmallservice(i,j) > 0 
                    numRoutessmallservice = numRoutessmallservice +1; %Checks if any new jobs can be added to the route
                    k = k+1; %Update counter
                    Asmallservice(:,numRoutessmallservice)=Asmallservice(:,numRoutessmallservice-k);
                    Timesmallservice(:,numRoutessmallservice)=Timesmallservice(:,numRoutessmallservice-k);
                    Store1smallservice = [Store1smallservice;j]; %Add new job to store.
                    Asmallservice(j,numRoutessmallservice) = 1; %Add new job to row
                    Timesmallservice(j,numRoutessmallservice) = Timesmallservice(i,numRoutessmallservice-k) + TravelDistancesmallservice(i,j) + JobDurationsmallservice(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1smallservice) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationsmallservice)
                        if (Timesmallservice(Store1smallservice(c),numRoutessmallservice-length(Store1smallservice)+c-length(Store2smallservice))+TravelDistancesmallservice(Store1smallservice(c),j))<TimeWindowsmallservice(j)...
                            && TravelDistancesmallservice(Store1smallservice(c),j) >0 && Asmallservice(j,numRoutessmallservice-length(Store1smallservice)+c-length(Store2smallservice)) == 0 %Checks if any new jobs can be added to the route
                            numRoutessmallservice = numRoutessmallservice + 1; %Add new route
                            Asmallservice(:,numRoutessmallservice)= Asmallservice(:,numRoutessmallservice-length(Store1smallservice)-length(Store2smallservice)-1+c);
                            Timesmallservice(:,numRoutessmallservice)= Timesmallservice(:,numRoutessmallservice-length(Store1smallservice)-length(Store2smallservice)-1+c);
                            Asmallservice(j,numRoutessmallservice) = 1; %Add new job to row
                            Timesmallservice(j,numRoutessmallservice) = Timesmallservice(Store1smallservice(c),numRoutessmallservice-length(Store1smallservice)-length(Store2smallservice)-1+c)+TravelDistancesmallservice(Store1smallservice(c),j)+JobDurationsmallservice(j); %Update time in time matrix
                            Store2smallservice = [Store2smallservice;j]; %Add new job to store. 
                        end
                    end
                end
                Store1smallservice = Store2smallservice; %Move new jobs in store to first store matrix 
                Store2smallservice = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end

Timesmallservice=Timesmallservice(:,any(Timesmallservice)); %Removes all the left over rows in time meatrix
[M,I]=max(Timesmallservice);
plusshjelpsmallservice=DistanceFromDepotsmallservice';

    
Timeloopsmallservice=(M+plusshjelpsmallservice(I));%adds the traveling time back to base to the time of each route

Costloopsmallservice=Costtimesmallservice*Timeloopsmallservice;  %Crates a cost matrix by multiplying time used in each loop with the cost per hour for each vessel    


Asmallservice=Asmallservice(:,any(Asmallservice)); %Removes all the left over rows in the route matrix, as the matrix size was predefined and to large


%
%
% This section creates all loops for the small well-boats. The section is
% the same as for the small service vessel



Timesmallwellboats = zeros(taskspr*lokas,40000); %Create Time matrix

Asmallwellboats = zeros(taskspr*lokas,40000); %Create binary feasible routes matrix
numRoutessmallwellboats = 0; %Set initial number of feasible routes


for i = 1:length(DistanceFromDepotsmallwellboats)
    k = 0;
   
    if DistanceFromDepotsmallwellboats(i) < TimeWindowsmallwellboats(i) %Check feasible start jobs. 
        numRoutessmallwellboats = numRoutessmallwellboats + 1; %Create a route for each feasible start job.
        Asmallwellboats(i,numRoutessmallwellboats) = 1; %Add job to new row
        Timesmallwellboats(i,numRoutessmallwellboats) = DistanceFromDepotsmallwellboats(i) + JobDurationsmallwellboats(i); %Add new time to new row
        
        n = 1; %Set counter
        
        Store1smallwellboats = []; %Create store matrix 1 to keep track of jobs already visited
        Store2smallwellboats = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %Check new routes as long as more jobs can be added
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationsmallwellboats)
                    if (Timesmallwellboats(i,numRoutessmallwellboats) + TravelDistancesmallwellboats(i,j)) < TimeWindowsmallwellboats(j)...
                        && TravelDistancesmallwellboats(i,j) > 0 
                    numRoutessmallwellboats = numRoutessmallwellboats +1; %Add new route
                    k = k+1; %Update counter
                    Asmallwellboats(:,numRoutessmallwellboats)=Asmallwellboats(:,numRoutessmallwellboats-k);
                    Timesmallwellboats(:,numRoutessmallwellboats)=Timesmallwellboats(:,numRoutessmallwellboats-k);
                    Store1smallwellboats = [Store1smallwellboats;j]; %Add new job to store.
                    Asmallwellboats(j,numRoutessmallwellboats) = 1; %Add new job to row
                    Timesmallwellboats(j,numRoutessmallwellboats) = Timesmallwellboats(i,numRoutessmallwellboats-k) + TravelDistancesmallwellboats(i,j) + JobDurationsmallwellboats(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1smallwellboats) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationsmallwellboats)
                        if (Timesmallwellboats(Store1smallwellboats(c),numRoutessmallwellboats-length(Store1smallwellboats)+c-length(Store2smallwellboats))+TravelDistancesmallwellboats(Store1smallwellboats(c),j))<TimeWindowsmallwellboats(j)...
                            && TravelDistancesmallwellboats(Store1smallwellboats(c),j) >0 && Asmallwellboats(j,numRoutessmallwellboats-length(Store1smallwellboats)+c-length(Store2smallwellboats)) == 0
                            numRoutessmallwellboats = numRoutessmallwellboats + 1; %Add new route
                            Asmallwellboats(:,numRoutessmallwellboats)= Asmallwellboats(:,numRoutessmallwellboats-length(Store1smallwellboats)-length(Store2smallwellboats)-1+c);
                            Timesmallwellboats(:,numRoutessmallwellboats)= Timesmallwellboats(:,numRoutessmallwellboats-length(Store1smallwellboats)-length(Store2smallwellboats)-1+c);
                            Asmallwellboats(j,numRoutessmallwellboats) = 1; %Add new job to row
                            Timesmallwellboats(j,numRoutessmallwellboats) = Timesmallwellboats(Store1smallwellboats(c),numRoutessmallwellboats-length(Store1smallwellboats)-length(Store2smallwellboats)-1+c)+TravelDistancesmallwellboats(Store1smallwellboats(c),j)+JobDurationsmallwellboats(j); %Update time in time matrix
                            Store2smallwellboats = [Store2smallwellboats;j]; %Add new job to store. 
                        end
                    end
                end
                Store1smallwellboats = Store2smallwellboats; %Move new jobs in store to first store matrix 
                Store2smallwellboats = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end
Timesmallwellboats=Timesmallwellboats(:,any(Timesmallwellboats));

[M,I]=max(Timesmallwellboats);
plusshjelpsmallwellboats=DistanceFromDepotsmallwellboats';

    
Timeloopsmallwellboats=(M+plusshjelpsmallwellboats(I));

Costloopsmallwellboats=Costtimesmallwellboats*Timeloopsmallwellboats;        


Asmallwellboats=Asmallwellboats(:,any(Asmallwellboats));





%This section creates all loops for the large well-boats. The section is
% the same as for the small service vessel




TimeLargewell = zeros(taskspr*lokas,40000); %Create Time matrix

ALargewell = zeros(taskspr*lokas,40000); %Create binary feasible routes matrix
numRoutesLargewell = 0; %Set initial number of feasible routes



for i = 1:length(DistanceFromDepotLargewell)
    k = 0;
   
    if DistanceFromDepotLargewell(i) < TimeWindowLargewell(i) %Check feasible start jobs. 
        numRoutesLargewell = numRoutesLargewell + 1; %Create a route for each feasible start job.
        ALargewell(i,numRoutesLargewell) = 1; %Add job to new row
        TimeLargewell(i,numRoutesLargewell) = DistanceFromDepotLargewell(i) + JobDurationLargewell(i); %Add new time to new row
        
        n = 1; %Set counter
        
        Store1Largewell = []; %Create store matrix 1 to keep track of jobs already visited
        Store2Largewell = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %Check new routes as long as more jobs can be added
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationLargewell)
                    if (TimeLargewell(i,numRoutesLargewell) + TravelDistanceLargewell(i,j)) < TimeWindowLargewell(j)...
                        && TravelDistanceLargewell(i,j) > 0 
                    numRoutesLargewell = numRoutesLargewell +1; %Add new route
                    k = k+1; %Update counter
                    ALargewell(:,numRoutesLargewell)=ALargewell(:,numRoutesLargewell-k);
                    TimeLargewell(:,numRoutesLargewell)=TimeLargewell(:,numRoutesLargewell-k);
                    Store1Largewell = [Store1Largewell;j]; %Add new job to store.
                    ALargewell(j,numRoutesLargewell) = 1; %Add new job to row
                    TimeLargewell(j,numRoutesLargewell) = TimeLargewell(i,numRoutesLargewell-k) + TravelDistanceLargewell(i,j) + JobDurationLargewell(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1Largewell) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationLargewell)
                        if (TimeLargewell(Store1Largewell(c),numRoutesLargewell-length(Store1Largewell)+c-length(Store2Largewell))+TravelDistanceLargewell(Store1Largewell(c),j))<TimeWindowLargewell(j)...
                            && TravelDistanceLargewell(Store1Largewell(c),j) >0 && ALargewell(j,numRoutesLargewell-length(Store1Largewell)+c-length(Store2Largewell)) == 0
                            numRoutesLargewell = numRoutesLargewell + 1; %Add new route
                            
                            ALargewell(:,numRoutesLargewell)= ALargewell(:,numRoutesLargewell-length(Store1Largewell)-length(Store2Largewell)-1+c);
                            TimeLargewell(:,numRoutesLargewell)= TimeLargewell(:,numRoutesLargewell-length(Store1Largewell)-length(Store2Largewell)-1+c);
                            
                            ALargewell(j,numRoutesLargewell) = 1; %Add new job to row
                            TimeLargewell(j,numRoutesLargewell) = TimeLargewell(Store1Largewell(c),numRoutesLargewell-length(Store1Largewell)-length(Store2Largewell)-1+c)+TravelDistanceLargewell(Store1Largewell(c),j)+JobDurationLargewell(j); %Update time in time matrix
                            Store2Largewell = [Store2Largewell;j]; %Add new job to store. 
                        end
                    end
                end
                Store1Largewell = Store2Largewell; %Move new jobs in store to first store matrix 
                Store2Largewell = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end

TimeLargewell=TimeLargewell(:,any(TimeLargewell));
[M,I]=max(TimeLargewell);
plusshjelpLargewell=DistanceFromDepotLargewell';

    
TimeloopLargewell=(M+plusshjelpLargewell(I));

CostloopLargewell=CosttimeLargewell*TimeloopLargewell;        


ALargewell=ALargewell(:,any(ALargewell));




%This section creates all loops for the large service vessels. The section is
% the same as for the small service vessel



TimeLargeservice = zeros(taskspr*lokas,700000); %Create Time matrix

ALargeservice = zeros(taskspr*lokas,700000); %Create binary feasible routes matrix
numRoutesLargeservice = 0; %Set initial number of feasible routes


for i = 1:length(DistanceFromDepotLargeservice)
    k = 0;
   
    if DistanceFromDepotLargeservice(i) < TimeWindowLargeservice(i) %Check feasible start jobs. 
        numRoutesLargeservice = numRoutesLargeservice + 1; %Create a route for each feasible start job.
        ALargeservice(i,numRoutesLargeservice) = 1; %Add job to new row
        TimeLargeservice(i,numRoutesLargeservice) = DistanceFromDepotLargeservice(i) + JobDurationLargeservice(i); %Add new time to new row
        
        n = 1; %Set counter
        
        Store1 = []; %Create store matrix 1 to keep track of jobs already visited
        Store2 = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %Check new routes as long as more jobs can be added
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationLargeservice)
                    if (TimeLargeservice(i,numRoutesLargeservice) + TravelDistanceLargeservice(i,j)) < TimeWindowLargeservice(j)...
                        && TravelDistanceLargeservice(i,j) > 0 
                    numRoutesLargeservice = numRoutesLargeservice +1; %Add new route
                    k = k+1; %Update counter
                    ALargeservice(:,numRoutesLargeservice)=ALargeservice(:,numRoutesLargeservice-k);
                    TimeLargeservice(:,numRoutesLargeservice)=TimeLargeservice(:,numRoutesLargeservice-k);
                    Store1 = [Store1;j]; %Add new job to store.
                    ALargeservice(j,numRoutesLargeservice) = 1; %Add new job to row
                    TimeLargeservice(j,numRoutesLargeservice) = TimeLargeservice(i,numRoutesLargeservice-k) + TravelDistanceLargeservice(i,j) + JobDurationLargeservice(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationLargeservice)
                        if (TimeLargeservice(Store1(c),numRoutesLargeservice-length(Store1)+c-length(Store2))+TravelDistanceLargeservice(Store1(c),j))<TimeWindowLargeservice(j)...
                            && TravelDistanceLargeservice(Store1(c),j) >0 && ALargeservice(j,numRoutesLargeservice-length(Store1)+c-length(Store2)) == 0
                            numRoutesLargeservice = numRoutesLargeservice + 1; %Add new route
                            
                            ALargeservice(:,numRoutesLargeservice)= ALargeservice(:,numRoutesLargeservice-length(Store1)-length(Store2)-1+c);
                            TimeLargeservice(:,numRoutesLargeservice)= TimeLargeservice(:,numRoutesLargeservice-length(Store1)-length(Store2)-1+c);
                            
                            ALargeservice(j,numRoutesLargeservice) = 1; %Add new job to row
                            TimeLargeservice(j,numRoutesLargeservice) = TimeLargeservice(Store1(c),numRoutesLargeservice-length(Store1)-length(Store2)-1+c)+TravelDistanceLargeservice(Store1(c),j)+JobDurationLargeservice(j); %Update time in time matrix
                            Store2 = [Store2;j]; %Add new job to store. 
                        end
                    end
                end
                Store1 = Store2; %Move new jobs in store to first store matrix 
                Store2 = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end

TimeLargeservice=TimeLargeservice(:,any(TimeLargeservice));

[M,I]=max(TimeLargeservice);
plusshjelpLargeservice=DistanceFromDepotLargeservice';

    
TimeloopLargeservice=(M+plusshjelpLargeservice(I));

CostloopLargeservice=CosttimeLargeservice*TimeloopLargeservice;        


ALargeservice=ALargeservice(:,any(ALargeservice));





%This section creates all loops for the medium service vessels. The section is
% the same as for the small service vessel



TimeMediumservice = zeros(taskspr*lokas,200000); %Create Time matrix

AMediumservice = zeros(taskspr*lokas,200000); %Create binary feasible routes matrix
numRoutesMediumservice = 0; %Set initial number of feasible routes


for i = 1:length(DistanceFromDepotMediumservice)
    k = 0;
   
    if DistanceFromDepotMediumservice(i) < TimeWindowMediumservice(i) %Check feasible start jobs. 
        numRoutesMediumservice = numRoutesMediumservice + 1; %Create a route for each feasible start job.
        AMediumservice(i,numRoutesMediumservice) = 1; %Add job to new row
        TimeMediumservice(i,numRoutesMediumservice) = DistanceFromDepotMediumservice(i) + JobDurationMediumservice(i); %Add new time to new row
        
        n = 1; %Set counter
        
        Store1 = []; %Create store matrix 1 to keep track of jobs already visited
        Store2 = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %Check new routes as long as more jobs can be added
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationMediumservice)
                    if (TimeMediumservice(i,numRoutesMediumservice) + TravelDistanceMediumservice(i,j)) < TimeWindowMediumservice(j)...
                        && TravelDistanceMediumservice(i,j) > 0 
                    numRoutesMediumservice = numRoutesMediumservice +1; %Add new route
                    k = k+1; %Update counter
                    AMediumservice(:,numRoutesMediumservice)=AMediumservice(:,numRoutesMediumservice-k);
                    TimeMediumservice(:,numRoutesMediumservice)=TimeMediumservice(:,numRoutesMediumservice-k);
                    Store1 = [Store1;j]; %Add new job to store.
                    AMediumservice(j,numRoutesMediumservice) = 1; %Add new job to row
                    TimeMediumservice(j,numRoutesMediumservice) = TimeMediumservice(i,numRoutesMediumservice-k) + TravelDistanceMediumservice(i,j) + JobDurationMediumservice(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationMediumservice)
                        if (TimeMediumservice(Store1(c),numRoutesMediumservice-length(Store1)+c-length(Store2))+TravelDistanceMediumservice(Store1(c),j))<TimeWindowMediumservice(j)...
                            && TravelDistanceMediumservice(Store1(c),j) >0 && AMediumservice(j,numRoutesMediumservice-length(Store1)+c-length(Store2)) == 0
                            numRoutesMediumservice = numRoutesMediumservice + 1; %Add new route
                            
                            AMediumservice(:,numRoutesMediumservice)= AMediumservice(:,numRoutesMediumservice-length(Store1)-length(Store2)-1+c);
                            TimeMediumservice(:,numRoutesMediumservice)= TimeMediumservice(:,numRoutesMediumservice-length(Store1)-length(Store2)-1+c);
                            
                            AMediumservice(j,numRoutesMediumservice) = 1; %Add new job to row
                            TimeMediumservice(j,numRoutesMediumservice) = TimeMediumservice(Store1(c),numRoutesMediumservice-length(Store1)-length(Store2)-1+c)+TravelDistanceMediumservice(Store1(c),j)+JobDurationMediumservice(j); %Update time in time matrix
                            Store2 = [Store2;j]; %Add new job to store. 
                        end
                    end
                end
                Store1 = Store2; %Move new jobs in store to first store matrix 
                Store2 = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end

TimeMediumservice=TimeMediumservice(:,any(TimeMediumservice));

[M,I]=max(TimeMediumservice);
plusshjelpMediumservice=DistanceFromDepotMediumservice';

    
TimeloopMediumservice=(M+plusshjelpMediumservice(I));

CostloopMediumservice=CosttimeMediumservice*TimeloopMediumservice;        


AMediumservice=AMediumservice(:,any(AMediumservice));





%This section creates all loops for the medium service vessels with lice equipment. The section is
% the same as for the small service vessel





TimeMediumservicelice = zeros(taskspr*lokas,200000); %Create Time matrix

AMediumservicelice = zeros(taskspr*lokas,200000); %Create binary feasible routes matrix
numRoutesMediumservicelice = 0; %Set initial number of feasible routes


for i = 1:length(DistanceFromDepotMediumservicelice)
    k = 0;
   
    if DistanceFromDepotMediumservicelice(i) < TimeWindowMediumservicelice(i) %Check feasible start jobs. 
        numRoutesMediumservicelice = numRoutesMediumservicelice + 1; %Create a route for each feasible start job.
        AMediumservicelice(i,numRoutesMediumservicelice) = 1; %Add job to new row
        TimeMediumservicelice(i,numRoutesMediumservicelice) = DistanceFromDepotMediumservicelice(i) + JobDurationMediumservicelice(i); %Add new time to new row
        
        n = 1; %Set counter
        
        Store1 = []; %Create store matrix 1 to keep track of jobs already visited
        Store2 = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %Check new routes as long as more jobs can be added
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationMediumservicelice)
                    if (TimeMediumservicelice(i,numRoutesMediumservicelice) + TravelDistanceMediumservicelice(i,j)) < TimeWindowMediumservicelice(j)...
                        && TravelDistanceMediumservicelice(i,j) > 0 
                    numRoutesMediumservicelice = numRoutesMediumservicelice +1; %Add new route
                    k = k+1; %Update counter
                    AMediumservicelice(:,numRoutesMediumservicelice)=AMediumservicelice(:,numRoutesMediumservicelice-k);
                    TimeMediumservicelice(:,numRoutesMediumservicelice)=TimeMediumservicelice(:,numRoutesMediumservicelice-k);
                    Store1 = [Store1;j]; %Add new job to store.
                    AMediumservicelice(j,numRoutesMediumservicelice) = 1; %Add new job to row
                    TimeMediumservicelice(j,numRoutesMediumservicelice) = TimeMediumservicelice(i,numRoutesMediumservicelice-k) + TravelDistanceMediumservicelice(i,j) + JobDurationMediumservicelice(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationMediumservicelice)
                        if (TimeMediumservicelice(Store1(c),numRoutesMediumservicelice-length(Store1)+c-length(Store2))+TravelDistanceMediumservicelice(Store1(c),j))<TimeWindowMediumservicelice(j)...
                            && TravelDistanceMediumservicelice(Store1(c),j) >0 && AMediumservicelice(j,numRoutesMediumservicelice-length(Store1)+c-length(Store2)) == 0
                            numRoutesMediumservicelice = numRoutesMediumservicelice + 1; %Add new route
                            
                            AMediumservicelice(:,numRoutesMediumservicelice)= AMediumservicelice(:,numRoutesMediumservicelice-length(Store1)-length(Store2)-1+c);
                            TimeMediumservicelice(:,numRoutesMediumservicelice)= TimeMediumservicelice(:,numRoutesMediumservicelice-length(Store1)-length(Store2)-1+c);
                            
                            AMediumservicelice(j,numRoutesMediumservicelice) = 1; %Add new job to row
                            TimeMediumservicelice(j,numRoutesMediumservicelice) = TimeMediumservicelice(Store1(c),numRoutesMediumservicelice-length(Store1)-length(Store2)-1+c)+TravelDistanceMediumservicelice(Store1(c),j)+JobDurationMediumservicelice(j); %Update time in time matrix
                            Store2 = [Store2;j]; %Add new job to store. 
                        end
                    end
                end
                Store1 = Store2; %Move new jobs in store to first store matrix 
                Store2 = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end

TimeMediumservicelice=TimeMediumservicelice(:,any(TimeMediumservicelice));

[M,I]=max(TimeMediumservicelice);
plusshjelpMediumservicelice=DistanceFromDepotMediumservicelice';

    
TimeloopMediumservicelice=(M+plusshjelpMediumservicelice(I));

CostloopMediumservicelice=CosttimeMediumservicelice*TimeloopMediumservicelice;        


AMediumservicelice=AMediumservicelice(:,any(AMediumservicelice));





%This section creates all loops for the Large service vessels with lice equipment. The section is
% the same as for the small service vessel



TimeLargeservicelice = zeros(taskspr*lokas,300000); %Create Time matrix

ALargeservicelice = zeros(taskspr*lokas,300000); %Create binary feasible routes matrix
numRoutesLargeservicelic = 0; %Set initial number of feasible routes


for i = 1:length(DistanceFromDepotLargeservicelice)
    k = 0;
   
    if DistanceFromDepotLargeservicelice(i) < TimeWindowLargeservicelice(i) %Check feasible start jobs. 
        numRoutesLargeservicelic = numRoutesLargeservicelic + 1; %Create a route for each feasible start job.
        ALargeservicelice(i,numRoutesLargeservicelic) = 1; %Add job to new row
        TimeLargeservicelice(i,numRoutesLargeservicelic) = DistanceFromDepotLargeservicelice(i) + JobDurationLargeservicelice(i); %Add new time to new row
        
        n = 1; %Set counter
        
        Store1 = []; %Create store matrix 1 to keep track of jobs already visited
        Store2 = []; %Create store matrix 2 to add new jobs in storage.
        while n<=1 %Check new routes as long as more jobs can be added
            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobDurationLargeservicelice)
                    if (TimeLargeservicelice(i,numRoutesLargeservicelic) + TravelDistanceLargeservicelice(i,j)) < TimeWindowLargeservicelice(j)...
                        && TravelDistanceLargeservicelice(i,j) > 0 
                    numRoutesLargeservicelic = numRoutesLargeservicelic +1; %Add new route
                    k = k+1; %Update counter
                    ALargeservicelice(:,numRoutesLargeservicelic)=ALargeservicelice(:,numRoutesLargeservicelic-k);
                    TimeLargeservicelice(:,numRoutesLargeservicelic)=TimeLargeservicelice(:,numRoutesLargeservicelic-k);
                    Store1 = [Store1;j]; %Add new job to store.
                    ALargeservicelice(j,numRoutesLargeservicelic) = 1; %Add new job to row
                    TimeLargeservicelice(j,numRoutesLargeservicelic) = TimeLargeservicelice(i,numRoutesLargeservicelic-k) + TravelDistanceLargeservicelice(i,j) + JobDurationLargeservicelice(j); %Update time in time matrix
                    end
                end
            else 
                for c = 1:length(Store1) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobDurationLargeservicelice)
                        if (TimeLargeservicelice(Store1(c),numRoutesLargeservicelic-length(Store1)+c-length(Store2))+TravelDistanceLargeservicelice(Store1(c),j))<TimeWindowLargeservicelice(j)...
                            && TravelDistanceLargeservicelice(Store1(c),j) >0 && ALargeservicelice(j,numRoutesLargeservicelic-length(Store1)+c-length(Store2)) == 0
                            numRoutesLargeservicelic = numRoutesLargeservicelic + 1; %Add new route
                            
                            ALargeservicelice(:,numRoutesLargeservicelic)= ALargeservicelice(:,numRoutesLargeservicelic-length(Store1)-length(Store2)-1+c);
                            TimeLargeservicelice(:,numRoutesLargeservicelic)= TimeLargeservicelice(:,numRoutesLargeservicelic-length(Store1)-length(Store2)-1+c);
                            
                            ALargeservicelice(j,numRoutesLargeservicelic) = 1; %Add new job to row
                            TimeLargeservicelice(j,numRoutesLargeservicelic) = TimeLargeservicelice(Store1(c),numRoutesLargeservicelic-length(Store1)-length(Store2)-1+c)+TravelDistanceLargeservicelice(Store1(c),j)+JobDurationLargeservicelice(j); %Update time in time matrix
                            Store2 = [Store2;j]; %Add new job to store. 
                        end
                    end
                end
                Store1 = Store2; %Move new jobs in store to first store matrix 
                Store2 = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    end
end

TimeLargeservicelice=TimeLargeservicelice(:,any(TimeLargeservicelice));

[M,I]=max(TimeLargeservicelice);
plusshjelpLargeservicelice=DistanceFromDepotLargeservicelice';

    
TimeloopLargeservicelice=(M+plusshjelpLargeservicelice(I));

CostloopLargeservicelice=CosttimeLargeservicelice*TimeloopLargeservicelice;        


ALargeservicelice=ALargeservicelice(:,any(ALargeservicelice));



%
%
%
%
% Now all the loops for all the vessels are combined with the time each
% loop takes and the vessel number performing the loop and the cost of
% performing the loop
%
%
%
%
%


Smallwellwithtimeandcost=[Asmallwellboats;Timeloopsmallwellboats;Costloopsmallwellboats;ones(1,size(Asmallwellboats,2))];

Largewellwithtimeandcost=[ALargewell;TimeloopLargewell;CostloopLargewell;2.*ones(1,size(ALargewell,2))];

Smallservicewithtimeandcost=[Asmallservice;Timeloopsmallservice;Costloopsmallservice;3.*ones(1,size(Asmallservice,2))];

Mediumservicewithtimeandcost=[AMediumservice;TimeloopMediumservice;CostloopMediumservice;4.*ones(1,size(AMediumservice,2))];

Largeservicewithtimeandcost=[ALargeservice;TimeloopLargeservice;CostloopLargeservice;5.*ones(1,size(ALargeservice,2))];

Mediumservicelicewithtimeandcost=[AMediumservicelice;TimeloopMediumservicelice;CostloopMediumservicelice;6.*ones(1,size(AMediumservicelice,2))];

Largeservicelicewithtimeandcost=[ALargeservicelice;TimeloopLargeservicelice;CostloopLargeservicelice;7.*ones(1,size(ALargeservicelice,2))];



%All Duplicate loops are removed

Bsmallwell = unique(Smallwellwithtimeandcost','rows');

BLargewell = unique(Largewellwithtimeandcost','rows');

BSmallservice = unique(Smallservicewithtimeandcost','rows');

BMediumservice = unique(Mediumservicewithtimeandcost','rows');

BLargeservice = unique(Largeservicewithtimeandcost','rows');

BMediumservicelice = unique(Mediumservicelicewithtimeandcost','rows');

BLargeservicelice = unique(Largeservicelicewithtimeandcost','rows');

%All loops for all vessels are combined in one matrix

Alluniqueloops=[Bsmallwell',BLargewell',BSmallservice',BMediumservice',BLargeservice',BMediumservicelice',BLargeservicelice'];




nloops=length(Alluniqueloops);%Finds the number of loops created, to be used in the XPRESS IVE model

%The next section of the script converts the loop matrix to three different
%matrixes, one for the jobs included in the loops, one for the cost of the
%loops and one for the time used on each loop. 

%Furthermore it converts the
%matrix with information about which jobs are in which loops into a two
%dimensional representation of a matrix with foure indices, as it is read
%when used in the XPRESS IVE model

% The cost and the time matrix are also converted into a format of which
% they are read in XPRESS IVE, as a two dimensional representation of a
% matrix with three indices

%This sorting proses will not be comented as it is only a set of row
%operations used to change the representation of the loop matrix from a
%normal two dimentional martix, to a representation of multidimentional
%marixes used in XPRESS IVE.

 ppp=Alluniqueloops';
 vvv=lokas;
 ttt=taskspr;
 eee=Vesseltypes;
 ooo=zeros(size(ppp,1),size(ppp,2)-3); % This line removes the cost, time and vesseltype from the loop matrix


for i=1:ttt  
         ooo(:,(vvv*i-(vvv-1)))= ppp(:,i);
end
  for j=2:(vvv-1)
        for i=1:ttt
ooo(:,i*vvv-(vvv-j))=ppp(:,((j-1)*ttt)+i);
        end
  end
  for i=1:ttt
  ooo(:,i*vvv)=ppp(:,(vvv-1)*ttt+i);
  end
 
      
  xxx=zeros(size(ooo,1)*eee,size(ooo,2));
  xxx(1,:)=ooo(1,:);
 for i=2:size(Bsmallwell,1)
     xxx(i+(eee-1)*(i-1),:)=ooo(i,:);
 end
 
 xxx(eee*size(Bsmallwell,1)+2,:)=ooo(size(Bsmallwell,1)+1,:);
 for i=size(Bsmallwell,1)+2:size(Bsmallwell,1)+size(BLargewell,1)
      xxx((i+(eee-1)*(i-1)+1),:)=ooo(i,:);
 end
 xxx(eee*(size(Bsmallwell,1)+size(BLargewell,1))+3,:)=ooo((size(Bsmallwell,1)+size(BLargewell,1))+1,:);
 for i=size(Bsmallwell,1)+size(BLargewell,1)+2:size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)
      xxx((i+(eee-1)*(i-1)+2),:)=ooo(i,:);
 end
 
xxx(eee*(size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1))+4,:)=ooo((size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+1),:); 
  for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+2:size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)
      xxx((i+(eee-1)*(i-1)+3),:)=ooo(i,:);
  end
  
   xxx(eee*(size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1))+5,:)=ooo((size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+1),:); 
  for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+2:size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)
      xxx((i+(eee-1)*(i-1)+4),:)=ooo(i,:);
  end
  
  xxx(eee*(size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1))+6,:)=ooo((size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+1),:); 
  for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+2:size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+size(BMediumservicelice,1)
      xxx((i+(eee-1)*(i-1)+5),:)=ooo(i,:);
  end
  
   xxx(eee*(size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+size(BMediumservicelice,1))+7,:)=ooo((size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+size(BMediumservicelice,1)+1),:); 
  for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+size(BMediumservicelice,1)+2:size(Alluniqueloops',1)
      xxx((i+(eee-1)*(i-1)+6),:)=ooo(i,:);
 end 
 
 
 finalloopmatrix=xxx;
 
  timematrix=zeros(size(ppp,1),eee);
 costmatrix=zeros(size(ppp,1),eee);
 for i=1:size(Bsmallwell,1)
     timematrix(i,1)=ppp(i,ttt*vvv+1);
     costmatrix(i,1)=ppp(i,ttt*vvv+2);
 end
 
 for i=size(Bsmallwell,1):size(Bsmallwell,1)+size(BLargewell,1)
     timematrix(i,2)=ppp(i,ttt*vvv+1);
     costmatrix(i,2)=ppp(i,ttt*vvv+2);
 end
 
 for i=size(Bsmallwell,1)+size(BLargewell,1):size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)
     timematrix(i,3)=ppp(i,ttt*vvv+1);
     costmatrix(i,3)=ppp(i,ttt*vvv+2);
 end
 
  for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1):size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)
     timematrix(i,4)=ppp(i,ttt*vvv+1);
     costmatrix(i,4)=ppp(i,ttt*vvv+2);
  end
 
   for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1):size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)
     timematrix(i,5)=ppp(i,ttt*vvv+1);
     costmatrix(i,5)=ppp(i,ttt*vvv+2);
   end
  
  for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1):size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+size(BMediumservicelice,1)
     timematrix(i,6)=ppp(i,ttt*vvv+1);
     costmatrix(i,6)=ppp(i,ttt*vvv+2);
  end
 
 for i=size(Bsmallwell,1)+size(BLargewell,1)+size(BSmallservice,1)+size(BMediumservice,1)+size(BLargeservice,1)+size(BMediumservicelice,1):size(Alluniqueloops',1)
     timematrix(i,7)=ppp(i,ttt*vvv+1);
     costmatrix(i,7)=ppp(i,ttt*vvv+2);
 end
 timematrix=round(timematrix);
 costmatrix=round(costmatrix);






%The next section prints the resulting loop, cost and time matrixes to a
%TXT document which is used as input in XPRESS IVE



% 
% 
fid=fopen('finalrunloops.txt','wt');
fprintf(fid,'nLoops : [\n');
fprintf(fid,'%g\t',nloops);
fprintf(fid,'\n');
fprintf(fid,']\n');
fprintf(fid,'loopslok : [\n');


for ii = 1:size(finalloopmatrix,1)
     fprintf(fid,'%g\t',finalloopmatrix(ii,:));
    fprintf(fid,'\n');
end

fprintf(fid,']\n');

 fprintf(fid,'\n');
  fprintf(fid,'\n');
   fprintf(fid,'\n');
    fprintf(fid,'\n');
    
fprintf(fid,'LoopTime :	[\n');

for ii = 1:size(timematrix,1)
     fprintf(fid,'%g\t',timematrix(ii,:));
    fprintf(fid,'\n');
end

fprintf(fid,']\n');

 fprintf(fid,'\n');
  fprintf(fid,'\n');
   fprintf(fid,'\n');
    fprintf(fid,'\n');

fprintf(fid,'LoopCost : [\n');

for ii = 1:size(costmatrix,1)
     fprintf(fid,'%g\t',costmatrix(ii,:));
    fprintf(fid,'\n');
end

fprintf(fid,']\n');

fclose(fid)



 toc
load handel
sound(y)